package jkje.swing;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class JFloatButton extends JButton implements
  MouseListener, FocusListener {

  private Color floatColor;

    public JFloatButton() {
        this( null, null );
    }

    public JFloatButton(Icon icn) {
        this(null, icn);
    }

    public JFloatButton(String txt) {
        this(txt, null);
    }

    public JFloatButton(String txt, Icon icn) {
        super(txt, icn);
        setOpaque(true);
        addMouseListener(this);
        addFocusListener(this);
    }

    public void setFloatColor(Color c) {
        floatColor=c;
    }
    public Color getFloatColor() {
        return floatColor;
    }

    public void setEnabled(boolean e) {
        super.setEnabled(e);
//        setRequestFocusEnabled(e);
    }

    public void addNotify() {
        super.addNotify();
        if (floatColor==null)
            floatColor=getParent().getBackground();
        setFloatedOver(false);
    }

    public void setFloatedOver(boolean fo) {
        if (!isEnabled())
            fo=false;
//            return;
        if (fo)
            setBackground(floatColor);
        else
            setBackground(getParent().getBackground());
        setOpaque(fo);
        setBorderPainted(fo);
        repaint();
    }

    public void mouseEntered(MouseEvent e) {
        setFloatedOver(true);
    }
    public void mouseExited(MouseEvent e) {
//        if (!hasFocus())
            setFloatedOver(false);
    }
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}

    public void focusGained(FocusEvent e) {
        setFloatedOver(true);
    }
    public void focusLost(FocusEvent e) {
        setFloatedOver(false);
    }

}